<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "data_element".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DataElement".
 *
 * Columns in table "data_element" available as properties of the model,
 * followed by relations of table "data_element" available as properties of the model.
 *
 * @property integer $id
 * @property integer $data_element_category_id
 * @property string $name
 * @property string $category
 *
 * @property DataElementCategory $dataElementCategory
 * @property DataElementProductElement[] $dataElementProductElements
 */
abstract class BaseDataElement extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'data_element';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DataElement|DataElements', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('id, data_element_category_id, name, category', 'required'),
            array('id, data_element_category_id', 'numerical', 'integerOnly'=>true),
            array('name, category', 'length', 'max'=>45),
            array('id, data_element_category_id, name, category', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'dataElementCategory' => array(self::BELONGS_TO, 'DataElementCategory', 'data_element_category_id'),
            'dataElementProductElements' => array(self::HAS_MANY, 'DataElementProductElement', 'data_element_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'data_element_category_id' => null,
            'name' => Yii::t('app', 'Name'),
            'category' => Yii::t('app', 'Category'),
            'dataElementCategory' => null,
            'dataElementProductElements' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('data_element_category_id', $this->data_element_category_id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('category', $this->category, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
